/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 178 by dpavlin, Tue Mar 16 15:06:30 2010 UTC revision 216 by dpavlin, Wed May 26 10:19:05 2010 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /bin/sh
2    ### BEGIN INIT INFO
3  # based on Tony Risinger code from lxc-users  # Provides:          lxc-watchdog
4    # Required-Start:    $remote_fs $named $network $time
5    # Required-Stop:     $remote_fs $named $network
6    # Required-Start:    
7    # Required-Stop:    
8    # Default-Start:     2 3 4 5
9    # Default-Stop:      0 1 6
10    # Short-Description: Manage Linux Containers startup/shutdown
11    # Description:       Uses clever inotify hack to monitor container's
12    #                    halt/reboot events watching /var/run/utmp
13    ### END INIT INFO
14    
15    # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
16    #
17    # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
26    
 name=$1  
27    
28  if [ ! -e /var/lib/lxc/$name/config ] ; then  lxc_exists() {
29          echo "Usage: $0 name"          name=$1
30          ls /var/lib/lxc/*/config | cut -d/ -f5  
31          exit 1          if [ ! -e /var/lib/lxc/$name/config ] ; then
32  fi                  echo "Usage: $0 name"
33                    lxc_status
34                    exit 1
35            fi
36    }
37    
 rootfs=`grep lxc.rootfs /var/lib/lxc/$name/config | cut -d= -f2`  
 echo "$name rootfs $rootfs"  
38    
39  # cleanup init scripts which don't work in containers  lxc_rootfs() {
40  ls $rootfs/etc/rc?.d/*umountfs 2>/dev/null | xargs -i rm -v {}          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41  ls $rootfs/etc/rc?.d/*umountroot 2>/dev/null | xargs -i rm -v {}  }
42  ls $rootfs/etc/rc?.d/*hwclock* 2>/dev/null | xargs -i rm -v {}  
43    
44    lxc_status() {
45            ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
46                    boot="-"
47                    hostname=`cat $(lxc_rootfs $name)/etc/hostname`
48                    ip=`grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //'`
49                    test -s /var/lib/lxc/$name/on_boot && boot="boot"
50                    echo "$name $status $boot $(lxc_rootfs $name) $ip $hostname"
51            done ) | column -t
52    }
53    
54    
55    cleanup_init_scripts() {
56            rootfs=$(lxc_rootfs $1)
57    
58            ls \
59                    $rootfs/etc/rc?.d/*umountfs \
60                    $rootfs/etc/rc?.d/*umountroot \
61                    $rootfs/etc/rc?.d/*hwclock* \
62            2>/dev/null | xargs -i rm -v {}
63    }
64    
65    
66    setup_inittab() {
67            rootfs=$(lxc_rootfs $1)
68            remove=$2
69            add=$3
70    
71            # let container respond to kill -SIGPWR
72            inittab=$rootfs/etc/inittab
73            if ! grep "$add" ${inittab} >/dev/null ; then
74                    grep -v "$remove" ${inittab} > ${inittab}.new
75                    echo $add >> ${inittab}.new
76                    mv ${inittab}.new ${inittab}
77                    echo "$inittab modified with $add"
78            fi
79    }
80    
81    
82    lxc_log() {
83            echo `date +%Y-%m-%dT%H:%M:%S` $*
84    }
85    
86    
87    lxc_kill() {
88            name=$1
89            sig=$2
90    
91            init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
92            if [ -z "$init_pid" ] ; then
93                    lxc-info -n $name
94                    exit 1
95            fi
96            lxc_log "$name kill $sig $init_pid"
97            /bin/kill $sig $init_pid
98    }
99    
100    lxc_stop() {
101            lxc_log "$name stop"
102            lxc_kill $name -SIGPWR
103            lxc-wait -n $name -s STOPPED
104            lxc_log "$name stoped"
105    #       rm -f /var/lib/lxc/${name}/on_boot
106    }
107    
108    
109    lxc_start() {
110            name=$1
111    
112            if ! lxc-info -n $name | grep RUNNING ; then
113                    lxc_log "$name start"
114                    lxc-start -n $name -o /tmp/${name}.log -d
115                    lxc-wait  -n $name -s RUNNING
116                    lxc-info  -n $name
117                    test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
118            fi
119    }
120    
121  lxc-info -n $name | grep RUNNING || lxc-start -d -n $name -o /tmp/${name}.log && echo "$name start"  lxc_watchdog() {
122    name=$1
123    rootfs=$(lxc_rootfs $1)
124    
125  while true; do  while true; do
         # time of 5 minutes on it JUST IN CASE...  
126          vps_utmp=${rootfs}/var/run/utmp          vps_utmp=${rootfs}/var/run/utmp
127          inotifywait -qqt 300 ${vps_utmp}          tasks=`wc -l < /cgroup/${name}/tasks`
128          if [ $(wc -l < /cgroup/${name}/tasks) -eq 1 ]; then          test -z "$tasks" && exit 1
129            if [ "$tasks" -eq 1 ]; then
130    
131                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel ${vps_utmp})"
132                  echo "# $name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
133    
134                  case $runlevel in                  case $runlevel in
135                  N*)                  N*)
136                          # nothing for new boot state                          # nothing for new boot state
137                  ;;                  ;;
138                  ??0)                  ??0)
139                          echo "$name halt"                          lxc_log "$name halt"
140                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
141                            lxc-wait -n ${name} -s STOPPED
142                          break                          break
143                  ;;                  ;;
144                  ??6)                  ??6)
145                          echo "$name reboot";                          lxc_log "$name reboot";
146                          lxc-stop -n ${name}                          lxc-stop -n ${name}
147                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
                         mount /mnt/llin -o remount,rw  
148                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
149                  ;;                  ;;
150                  *)                  *)
# Line 54  while true; do Line 153  while true; do
153                          [ "$state" = "RUNNING" ] || break                          [ "$state" = "RUNNING" ] || break
154                  ;;                  ;;
155                  esac                  esac
156            else
157                    lxc_log "$name $tasks tasks"
158          fi          fi
159    
160            # time of 5 minutes on it JUST IN CASE...
161            inotifywait -qqt 300 ${vps_utmp}
162  done  done
163    
164    lxc_log "$name watchdog exited"
165    
166    }
167    
168    
169    usage() {
170            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
171            exit 3
172    }
173    
174    command_on_lxc() {
175    command=$1
176    shift
177    
178    echo "# $command $1"
179    
180    case "$command" in
181    
182    start)
183            lxc_exists $1
184            cleanup_init_scripts $1
185            setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
186            setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
187            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
188            lxc_start $1
189            # give container 5 seconds to start more than one process
190            ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
191            ;;
192    stop|halt)
193            lxc_exists $1
194            lxc_stop $1
195            ;;
196    reload|force-reload|restart|reboot)
197            lxc_kill $1 -SIGINT
198            ;;
199    watchdog)
200            lxc_watchdog $1
201            ;;
202    boot)
203            echo $1 > /var/lib/lxc/$1/on_boot
204            ;;
205    disable)
206            echo -n > /var/lib/lxc/$1/on_boot
207            ;;
208    *)
209            usage
210            ;;
211    
212    esac
213    
214    }
215    
216    command=$1
217    test -z "$command" && usage
218    test "$command" = "status" && lxc_status && exit
219    shift
220    
221    if [ -z "$1" ] ; then
222            ls /var/lib/lxc/*/on_boot | while read path ; do
223                    name=`echo $path | cut -d/ -f5`
224                    if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
225                            command_on_lxc $command $name
226                    else
227                            echo "# skip $command $name"
228                    fi
229            done
230    else
231            while [ ! -z "$1" ] ; do
232                    command_on_lxc $command $1
233                    shift
234            done
235    fi
236    

Legend:
Removed from v.178  
changed lines
  Added in v.216

  ViewVC Help
Powered by ViewVC 1.1.26